# modified by Masaki Shnomiya   5 Oct 2002
# originally from Jun Wakaya 2000
# ISBN4-7978-2014-4 

#set gf_fontName ""
#set gf_fontSize 10
set  gf_fontWeight ""
set gf_fontSlant ""
#set m(ok) "OK"
# set m(cancel) "Cancel"
# set fax(locale) "ja"

#--------------------------------------------------------------------------
# edit font attribute
#--------------------------------------------------------------------------

proc edit_font { font } {
       global fax m confwindow gf_fontName gf_fontSize gf_fontWeight gf_fontSlant

       if [string match  {-*} $font ] {
           set fl [split $font {-}]
           set f [lindex $fl 2]
           set s [lindex $fl 7]
           set weight [lindex $fl 3]
           set slant [lindex $fl 4]
       } else {
           set fl [split $font { }]
           set f [lindex $fl 0]
           set s [lindex $fl 1] 
           set weight [lindex $fl 1]
           set slant [lindex $fl 2]
       }
# for debygging
#text_viewer "edit_font" "Font family:$f\nFont size:$s\nFont Weight:$weight\nSlant:$slant"

       if { $f == "" } { set f "courier" }
       if { $s < 8 } { set s 12 }
       if [string match b* $weight] { set weight bold } else { set weight normal }
       if [string match i* $slant] { set slant italic } else { set slant roman } 
       set gf_fontName $f
       set gf_fontSize $s
       set gf_fontWeight $weight
       set gf_fontSlant $slant

       return "[tk_GetFont $confwindow.gf ]"
}

proc tk_GetFont {w} {
        global fax m
	global tcl_platform gf_font gf_fontName gf_fontSize gf_fontWeight gf_fontSlant \
                  gf_weightList gf_slantList gf_weight gf_slant gf_savesize

	if {[winfo exists $w]} return

	toplevel $w
	grab $w

	set locale $fax(locale)
        set myfont   {defaultgui 12}
        set buttonfont   {Mincho:Helvetica-Bold-12}
        set sampletext "ABCDE fghij"
        switch -- $locale {
              "ja" {set sampletext "$sampletext ܸ" }
              "ko" {set sampletext "$sampletext ѱ" }
              default {}
         }
         set startfont "$gf_fontName $gf_fontSize $gf_fontWeight $gf_fontSlant"
        set gf_weightList [list normal bold]
        set gf_slantList [list roman italic]
        set gf_font ""
	set gf_savesize 0

#	if {$tcl_platform(platform)=="macintosh"} {
		wm title $w "Choose Font"
#	} else {
#	}

	pack [frame $w.u] -fill both -padx 5 -pady 5
	pack [frame $w.m -relief sunken -bd 1] -fill both -padx 10 -pady 5
	pack [frame $w.l] -fill both -padx 5 -pady 5

	pack [frame $w.u.l -relief sunken -bd 1] \
		[frame $w.u.r -relief sunken -bd 1] \
		-fill both -side left -padx 5

	pack [listbox $w.u.l.lb -yscrollcommand "$w.u.l.sb set" \
		-bg #cfcfcf -relief flat -width 32 -font $myfont \
		-selectmode single -takefocus 0] \
		[scrollbar $w.u.l.sb -command "$w.u.l.lb yview"] \
	-fill both -side left

	pack [scale $w.u.r.s -orient vertical -from 8 -to 72 -relief flat \
		-variable gf_fontSize -command "gf_preview_size $w"] -fill both -side left

        pack [checkbutton $w.m.b -text "Bold" -font "$myfont bold" -variable gf_weight \
			-command "gf_preview_font $w"] \
                [checkbutton $w.m.i -text "Italic" -font "$myfont normal italic"  -variable gf_slant \
			-command "gf_preview_font $w"] \
			 -side left -fill both -padx 5

        pack [label $w.l.text -text $sampletext -font $startfont  -relief groove -bd 1 -padx 5] \
		-side left -fill both -padx 5
	pack [button $w.l.cancel -text $m(cancel) -font $buttonfont \
                 -command "gf_cancel $w"] \
		[button $w.l.ok -text $m(ok)  -font $buttonfont \
                 -command "gf_ok $w" \
		  -default active] \
		-side right -fill both -padx 5
	focus $w.l.ok

	set gf_fBox $w.u.l.lb
        bind $gf_fBox <ButtonRelease-1> "gf_preview_font $w"

        set gf_fontList [font families]
        set gf_fontList [concat $gf_fontList [font names]]
	set gf_fontList [lsort $gf_fontList]

	foreach i $gf_fontList {
		$gf_fBox insert end $i
	}

        set fontkey [string trimleft [string trimright $gf_fontName \} ] \} ]
        set fontnumber [lsearch -exact $gf_fontList $fontkey]
        if { $fontnumber <0 } { set fontnumber 0 }
	$gf_fBox selection set $fontnumber
        $gf_fBox see $fontnumber

        set gf_weight [lsearch -exact $gf_weightList $gf_fontWeight]
        if { $gf_weight < 0 } { set weight 0 }   
        set gf_slant [lsearch -exact $gf_slantList $gf_fontSlant]        
        if { $gf_slant < 0 } { set slant 0 }

	gf_preview_font $w

	tkwait window $w
        return "$gf_font"
}

proc gf_ok {w} {
	global gf_font 
        set gf_font "[gf_preview_font $w]"
	destroy $w
        return "gf_font" 
}

proc gf_cancel {w} {
	global gf_font 
	destroy $w
        set gf_font ""
        return ""
}

proc gf_preview_size { w n } {
        gf_preview_font  $w
}

proc gf_preview_font {w} {
	global gf_font gf_fontName gf_fontSize gf_fontWeight gf_fontSlant
        global gf_weightList gf_slantList gf_weight gf_slant gf_savesize gf_saveweight gf_saveslant

	set gf_fBox $w.u.l.lb

       foreach i [list $w.u.r.s $w.m.b $w.m.i] {
              $i configure -state normal
       }
	if { $gf_savesize > 0 } {
		set gf_fontSize $gf_savesize
		set gf_weight	$gf_saveweight
		set gf_slant $gf_saveslant
		set gf_savesize 0
	}

	set gf_fontName [$gf_fBox get [$gf_fBox curselection]]
        set gf_fontWeight [lindex $gf_weightList $gf_weight]
        set gf_fontSlant [lindex $gf_slantList $gf_slant]
	
	switch -glob -- $gf_fontName {
		 {*-[0-9][0-9]} {
				set gf_font "$gf_fontName"
				set gf_savesize $gf_fontSize
				set gf_saveweight	$gf_weight
				set gf_saveslant	$gf_slant
				set tempfl  [split $gf_font {-} ]
				set tempsize [lindex $tempfl end]
				if { [lsearch -glob $tempfl {[Bb]old}] > 0 } {set gf_weight 1} else { set gf_weight 0 }
				if { [lsearch -glob $tempfl {[Ii]talic}] > 0 } {set gf_slant 1 } else { set gf_slant 0 }
				set gf_fontSize $tempsize
				foreach i [list $w.u.r.s $w.m.b $w.m.i] {
 					$i configure -state disabled
				}
			}
               {*[ ]*}           { set gf_font  "\{$gf_fontName\} $gf_fontSize $gf_fontWeight $gf_fontSlant"  }
               default         { set gf_font  "$gf_fontName $gf_fontSize $gf_fontWeight $gf_fontSlant"   }   }
        $w.l.text configure -font "$gf_font"
        return "$gf_font"
}
