%define fname tkscanfax
%define subname 1
Version: 1.1.8
Name: %{fname}%{subname}
Release: 0
Summary: Tk/Tcl based GUI scanner and fax program
Summary(ja): GUIScannerFAXץ
License: GPL2
Url: http://shino.pos.to/linux/tkscanfax.html
Group: Applications/Communications
%define icondir %{_datadir}/pixmaps
%define applnkdir %{_datadir}/applications
%define kde    %([ -d %{_datadir}/applnk ] && echo 1 || echo 0)

Packager: Masaki SHINOMIYA <shino@pos.to>
Source: http://shino.pos.to/linux/%{fname}-%{version}.tar.gz

#prefix: %_prefix
Buildarch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: tk, tcl, ImageMagick, ghostscript, file
#Requires: netpbm-prog, a2ps, psutils 
#Requires: libgr-progs, mpage     # for Vine
#Requires: efax >= 0.9a001114a6   # or mgetty+sendfax, or HylaFax
#Requires: libtiff	          # if use efax or Hylafax
#Requires: tetex, tetex-latex, tetex-ptex, tetex-dvips, tetex-fonts 
#Requires: pLaTeX2e, pTeX, dvipsk # for Vine
#Requires: sane-backends          # optional

%description
 A Tk/Tcl based frontend of mgetty+sendfax or efax combinated with a frontend
 of scanner hanndling. It helps making the cover page, converting text
 files, postscript files and image files into fax file and sending.
 It also use scaners by using backennds such as SANE. 
 The efax program supports Class-1 faxmodems.
%description -l ja
 Tcl/TkưGUIFAXץǤ
 Сڡκƥȡݥȥץȡե뤫
 FAXڡǤޤޤSANEʤɤȹ礻ʤȤޤ
 FAXץˤefaxmgetty+sendfaxȤޤefaxȤ
 CLASS1ޥɤΥǥ⥵ݡȤǤޤܸȤޤ

%prep
%setup -q -n %{name}

%build
make prefix=%{_prefix}

%install
make DESTDIR=%{buildroot} prefix=%{_prefix} install-prog
make DESTDIR=%{buildroot} prefix=%{_prefix} APPDIR=%{applnkdir} install-icon

%clean
rm -rf $RPM_BUILD_ROOT
#rm -rf $RPM_BUILD_DIR/%{name}

%files
%defattr(-, root, root)
%doc doc/ChangeLog doc/[I-T]* doc/*.sample* doc/*.sh doc/fax
%{_prefix}/bin/*
%dir %{_prefix}/lib/*
%{_prefix}/lib/*/*.tcl
%config(noreplace) %{_prefix}/lib/*/tk*
#%#config %{_prefix}/lib/*/*-conf.tcl
%dir %{_prefix}/lib/*/tex
%config %{_prefix}/lib/*/tex/*
%dir %{_prefix}/lib/*/scan-drivers
%config %{_prefix}/lib/*/scan-drivers/*
%{_prefix}/lib/*/images
%{_prefix}/lib/*/doc
%config(noreplace, missingok) %{icondir}/*
%config(noreplace, missingok) %{applnkdir}/*.desktop
%if %kde
%config(missingok) %{_datadir}/applnk/*/*.desktop
%endif

%changelog
* Mon Feb 27 2007 Masaki Shinomiya <shino@pos.to> 1.1.8-0
- ready for LANG ja_JP.UTF-8

* Thu Jan 11 2007 Masaki Shinomiya <shino@pos.to>
- license instead of copyright, move applnkdir to %%_datadir/applications

* Thu Jan 13 2005 Masaki Shinomiya <shino@pos.to>
- KDE desktop

* Thu Sep 30 2004 Masaki Shinomiya <shino@pos.to>
- not install doc (for fedora)

* Tue Feb 25 2003 Masaki Shinomiya <shino@pos.to>
- 1.1.2
- bugfix in fax-pbook, terminal-none, last session, last cover, system info.
- platex on RHL7.x, tkscan lancher

* Tue Feb 25 2003 Masaki Shinomiya <shino@pos.to>
- 1.1.1
- bugfix in fax-pbook

* Fri Jan 24 2003 Masaki Shinomiya <shino@pos.to>
- 1.1.0.1
- fix problem in japanese version

* Wed Jan 15 2003 Masaki Shinomiya <shino@pos.to>
- 1.1.0
- HylaFax support

* Sun Mar 24 2002 Masaki Shinomiya <shino@pos.to>
- version 1.01-1(/usr/doc) , -2(/usr/share/doc) 
- bugfix in making faxes using scanners

- log browser, bugfixes, requires
* Mon Jan 28 2002 Masaki Shinomiya <shino@pos.to>
- version 1.0-1(/usr/doc) , -2(/usr/share/doc) 
- log browser, bugfixes, requires

* Sun Jan 20 2002 Masaki Shinomiya <shino@pos.to>
- version 0.99final-1(/usr/doc) , -2(/usr/share/doc) 
- log browser

* Mon Jan 14 2002 Masaki Shinomiya <shino@pos.to>
- version 0.99f-1
-  Keep fax pages of previous session.  Special charactors escaped. TkScan bugfix

* Sun Dec 16 2001 Masaki Shinomiya <shino@pos.to>
- version 0.99e-1
- TkScan bugfix, fax spooling bugfix, fax spooling with LPRng
- include fax script in doc

* Sun Oct 21 2001 Masaki Shinomiya <shino@pos.to>
- version 0.99d-1
- fax spooling bugfix, english typo

* Sun Oct 7 2001 Masaki Shinomiya <shino@pos.to>
- version 0.99c-1
- Support 'Fax Outgoing' box with efax spooling function. 
- Windows expandable 
- 'From', 'To' order in the cover page
- error traps in fax^pbook.tcl
- eliminate tex/cover-??.tex
- include html documents on efax settings

* Sat Sep 8 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.99b-1
  - fixed  some system does not work properly  when calling dvips
  - Japanese input method in Tk-8.3
  - try to keep proper size in image conversion
  - allow to run without LaTeX
  - support 'a2ps' in place of 'mpage' 
  - automatic configuration in selecting some commands for the system
  - configuration parameters
  - improved error trap

* Sat Aug 25 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.99a-1
  - looking up env(LANG)
  - fax-received box, fax print, fax view, english typo
  - images in documents

* Sun Jul 29 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.99-1, 1ja
  - add english documents

* Fri Jul 20 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91j1-0.5
  - Link with LyX in face cover page making, by Ryoji Kawagishi

* Wed Jul 4 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91j-0.5
  - GUI for face cover page making, by Ryoji Kawagishi

* Fri Jun 15 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.96e
  - launch fax-received window after receive completed
  - fixed misleading message after deleting fax page

* Thu Jun 14 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.95e
  - supports manual dialing
  - new scanner driver for SHARP JX-250

* Sun Jun 10 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.94e
  - fixed the problem in launching tkscan alone

* Sat Jun 9 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.93e
  - halftoning in scanner drivers, misc bugs fix
  - error logs to be colected in /var/log/fax
  - build architechture is now noarch

* Mon Jun 4 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.92e
  - Fixed image conversion

* Thu May 31 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.91e
  - Fixed printing nomal-mode fax

* Wed May 30 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.90e
  - Fixed printing, phone book, scroll mouse support

* Tue May 29 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.8efax2
  - Fixed scanning, printing, pbm to tiffg3

* Mon May 28 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.8efax1
  - Japanese TeX tenplate by Ryoji Kawagishi <kawagisi@yk.rim.or.jp>
  - bugfix in attaching text files

* Tue May 23 2001 Masaki Shinomiya <shino@pos.to>
  - version 0.91-0.8efax
  - Implemented internationalization.
  - Primitive epson-scanimage driver
